// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dbw_ford_msgs:msg/SurroundReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_FORD_MSGS__MSG__DETAIL__SURROUND_REPORT__TRAITS_HPP_
#define DBW_FORD_MSGS__MSG__DETAIL__SURROUND_REPORT__TRAITS_HPP_

#include "dbw_ford_msgs/msg/detail/surround_report__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const dbw_ford_msgs::msg::SurroundReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: cta_left_alert
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cta_left_alert: ";
    value_to_yaml(msg.cta_left_alert, out);
    out << "\n";
  }

  // member: cta_right_alert
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cta_right_alert: ";
    value_to_yaml(msg.cta_right_alert, out);
    out << "\n";
  }

  // member: cta_left_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cta_left_enabled: ";
    value_to_yaml(msg.cta_left_enabled, out);
    out << "\n";
  }

  // member: cta_right_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cta_right_enabled: ";
    value_to_yaml(msg.cta_right_enabled, out);
    out << "\n";
  }

  // member: blis_left_alert
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "blis_left_alert: ";
    value_to_yaml(msg.blis_left_alert, out);
    out << "\n";
  }

  // member: blis_right_alert
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "blis_right_alert: ";
    value_to_yaml(msg.blis_right_alert, out);
    out << "\n";
  }

  // member: blis_left_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "blis_left_enabled: ";
    value_to_yaml(msg.blis_left_enabled, out);
    out << "\n";
  }

  // member: blis_right_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "blis_right_enabled: ";
    value_to_yaml(msg.blis_right_enabled, out);
    out << "\n";
  }

  // member: sonar_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sonar_enabled: ";
    value_to_yaml(msg.sonar_enabled, out);
    out << "\n";
  }

  // member: sonar_fault
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sonar_fault: ";
    value_to_yaml(msg.sonar_fault, out);
    out << "\n";
  }

  // member: sonar
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.sonar.size() == 0) {
      out << "sonar: []\n";
    } else {
      out << "sonar:\n";
      for (auto item : msg.sonar) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const dbw_ford_msgs::msg::SurroundReport & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<dbw_ford_msgs::msg::SurroundReport>()
{
  return "dbw_ford_msgs::msg::SurroundReport";
}

template<>
inline const char * name<dbw_ford_msgs::msg::SurroundReport>()
{
  return "dbw_ford_msgs/msg/SurroundReport";
}

template<>
struct has_fixed_size<dbw_ford_msgs::msg::SurroundReport>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<dbw_ford_msgs::msg::SurroundReport>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<dbw_ford_msgs::msg::SurroundReport>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DBW_FORD_MSGS__MSG__DETAIL__SURROUND_REPORT__TRAITS_HPP_
